Graphics3D 1024,768,32,2
SeedRnd MilliSecs()
SetBuffer BackBuffer()
Local timer =CreateTimer(60)
WireFrame False

Include "Draw3D\Draw3D2.bb"

Global camera = CreateCamera()
Global WuerfelCamera

DrawInit3D(camera)
Global Font=FontRange3D(LoadImage3D("GFX\font\Babylon1.png",2,2,0,-100)):SetFont3D(Font,2,1,-4,0)
Global Font2=FontRange3D(LoadImage3D("GFX\font\Babylon1.png",2,2,0,-100)):SetFont3D(Font2,1,1,-4,0)

Local light = CreateLight(2)
PositionEntity light,0,15,8
AmbientLight 150,75,75
Global mx,my,mh1


;Bildschirmkonstanten
Global fullGraphicWidth = GraphicsWidth()
Global fullGraphicHeight = GraphicsHeight()
Global viertelGraphicWidth = fullGraphicWidth/4
Global halfGraphicsWidth = fullGraphicWidth/2
Global halfGraphicsHeight= fullGraphicHeight/2
Local grafikdivisorWidth# = halfGraphicsWidth/5.0
Local grafikdivisorHeight#= halfGraphicsHeight/10.0

;Das Kasino
Local msh_kasino = LoadMesh("Modelle\Kasino\Kasino.B3D")
EntityShininess msh_kasino,-1
ScaleEntity msh_kasino , .1,.1,.1
EntityOrder msh_kasino,0
;Die Spielerpositionen 0=X;1=Z;2=Angel
Dim PlayerPos#(4,2)
PlayerPos(0,0)=-10
PlayerPos(0,1)=3.5
PlayerPos(0,2)=-45
PlayerPos(1,0)=-3
PlayerPos(1,1)=1
PlayerPos(1,2)=0
PlayerPos(2,0)=3
PlayerPos(2,1)=1
PlayerPos(2,2)=0
PlayerPos(3,0)=10
PlayerPos(3,1)=3.5
PlayerPos(3,2)=45
;Startposition
PlayerPos(4,0)=0
PlayerPos(4,1)=-10
PlayerPos(4,2)=0

Local msh_wuerfel_original = LoadMesh("Modelle\Wuerfel\wuerfel.b3d")
ScaleEntity msh_wuerfel_original,.001,.001,.001
Dim WuerfelPos#(7,1)
WuerfelPos(0,0)=-7.5
WuerfelPos(0,1)=5.25
WuerfelPos(1,0)=-7.25
WuerfelPos(1,1)=5.5
WuerfelPos(2,0)=-3
WuerfelPos(2,1)=3.75
WuerfelPos(3,0)=-3.25
WuerfelPos(3,1)=3.5
WuerfelPos(4,0)=3
WuerfelPos(4,1)=3.75
WuerfelPos(5,0)=3.25
WuerfelPos(5,1)=3.5
WuerfelPos(6,0)=7.25
WuerfelPos(6,1)=5.25
WuerfelPos(7,0)=7.5
WuerfelPos(7,1)=5.0

Dim WuerfelDrehung(5,1); 0=X-Drehung 1=Z-Drehung
WuerfelDrehung(0,0)=0
WuerfelDrehung(0,1)=2
WuerfelDrehung(1,0)=1
WuerfelDrehung(1,1)=0
WuerfelDrehung(2,0)=0
WuerfelDrehung(2,1)=3
WuerfelDrehung(3,0)=2
WuerfelDrehung(3,1)=3
WuerfelDrehung(4,0)=3
WuerfelDrehung(4,1)=3
WuerfelDrehung(5,0)=0
WuerfelDrehung(5,1)=0


Local i
Dim Msh_Wuerfel(7)
For i=0 To 7
	Msh_Wuerfel(i) = CopyMesh(msh_wuerfel_original)
	PositionEntity Msh_Wuerfel(i),WuerfelPos(i,0),5,WuerfelPos(i,1)
	ScaleEntity Msh_Wuerfel(i),.0007,.0007,.0007
	RotateEntity Msh_Wuerfel(i),180,0,270
	EntityShininess Msh_Wuerfel(i),-1
Next


Local Msh_Kappe_original = LoadMesh("Modelle\Kappe\Kappe.b3d")
Dim Msh_Kappe(3)
For i=0 To 3
	Msh_Kappe(i)=CopyMesh(Msh_Kappe_original)
	PositionEntity Msh_Kappe(i),(WuerfelPos(i*2,0)+WuerfelPos(i*2+1,0))/2.0,4.8,(WuerfelPos(i*2,1)+WuerfelPos(i*2+1,1))/2.0
	ScaleEntity Msh_Kappe(i),.003,.003,.003
Next
FreeEntity(Msh_Kappe_original)

Dim Stuehle(3)
For i=0 To 3
	Stuehle(i) = LoadMesh("Modelle\Stuhl\stuhl.b3d")
	PositionEntity Stuehle(i),PlayerPos(i,0),1,PlayerPos(i,1)
	ScaleEntity Stuehle(i),.01,.01,.01
	EntityColor Stuehle(i),0,0,0
Next

Global msh_neu = LoadMesh ("Modelle\neu\neu.3ds")
ScaleEntity msh_neu, .7, .7, .7
MoveEntity msh_neu , 0, 4.5, 3
EntityAlpha msh_neu,.5
EntityColor msh_neu,200,200,0

Global msh_beenden = LoadMesh ("modelle\beenden\beenden.3ds")
MoveEntity msh_beenden , 0, 7, 12
EntityAlpha msh_beenden,.5
EntityPickMode msh_beenden,2
EntityColor msh_beenden,200,150,50

Dim Karten(8)
For i=1 To 9
	Karten(i-1)=LoadImage3D("gfx\karten\"+i+".png",1,2,0,-100+i)
	Karten(i-1)=GrabImage3D(Karten(i-1),0,0,150,250)
Next

;MAIN VARS
Global status
Const StatusEinleitung=0
Const StatusMenue=1
Const StatusCameraSchwenk=2
Const StatusWuerfeln=3
Const StatusAufdecken=4
Const StatusPlayerKarten=5
Const StatusKappeZu=6
Const StatusGameOver=7

;MenueVariablen
Global Menue=True
Global Menue_Hover_Kategorie=-1
Global Menue_Hover_Stuhl=-1

;Spielvariablen
Global KameraSchwenk=True, KameraSchwenkZiel=4, KappenAlpha#
Global aktplayer = 4
Global SpielerAnzahl
Global KappenAnimAuf,KappenAnimZu
Global WuerfelSumme
Dim SpielerEigenschaft(3)

;SpielER Variablen
Dim KartenSet$(4)
For i=0 To 4
	KartenSet$(i)="123456789"
Next

;KI
Local SaveFile$="KI\Ki.sets"
Local DateiGroesse=FileSize(SaveFile)
Local inputfile=ReadFile(SaveFile)
Global BesteSetsBank=CreateBank( DateiGroesse )
ReadBytes(BesteSetsBank, inputfile, 0, DateiGroesse)


Function StringToIntegerSet(KartenSet$)
	Local IntegerSet,i
	For i=1 To 9
		If Instr(KartenSet$,i) Then IntegerSet = IntegerSet + 2^(i-1) 
	Next
	Return IntegerSet
End Function

Function IntegerToStringSet$(IntegerSet)
	Local StringSet$
	For i=1 To 9
		If IntegerSet And 2^(i-1) Then StringSet = StringSet + i
	Next
	Return StringSet$
End Function




Repeat
	mx = MouseX()
	my = MouseY()
	mh1=MouseHit(1)
	
	Select status
		Case StatusEinleitung
			KameraSchwenken()
			If KameraSchwenk=False Then status=StatusMenue
			
		Case StatusMenue
			MenueSteuerung()
			
		Case StatusCameraSchwenk
			KameraSchwenken()
			If KameraSchwenk=False Then 
				status=StatusWuerfeln
				EntityAlpha (Msh_Kappe(aktplayer),1)
			EndIf
			If aktplayer<4
				If SpielerEigenschaft(aktplayer)=0 Then 
					status = StatusCameraSchwenk
					KameraSchwenkZiel = aktplayer+1
					If (aktplayer+1) > SpielerAnzahl Then KameraSchwenkZiel=0
				EndIf
			EndIf
			
		Case StatusWuerfeln
			Text3D(Font,0,-halfGraphicsHeight+85,"Spieler "+(aktplayer+1),1)
			Text3D(Font,0,-halfGraphicsHeight+50,"Leertaste zum Wrfeln",1)
			If KeyHit(57) Then status=StatusAufdecken:NeuWuerfeln()
			
		Case StatusAufdecken
			KappeAuf()
			If KappenAnimAuf=False Then status=StatusPlayerKarten
			
		Case StatusPlayerKarten
			KartenSteuerung(True)
			
		Case StatusKappeZu
			KappenAnimZu=True
			KappeZu()
			KartenSteuerung(False)
			If KappenAnimZu=False Then
				status = StatusCameraSchwenk
				KameraSchwenkZiel = aktplayer+1
				If (aktplayer+1) > SpielerAnzahl Then KameraSchwenkZiel=0
			EndIf	
			
		Case StatusGameOver
			Text3D(Font,0,35,"Spieler "+(aktplayer+1),1)
			Text3D(Font,0,0,"du bist raus",1)
			text3D(Font,0,-35,"Leertaste zum weitermachen",1)
			KartenSteuerung(False)
			SpielerEigenschaft(aktplayer)=0
			
			If KeyHit(57) Then 
				status=StatusKappeZu
				
				summe=0
				For i=0 To (SpielerAnzahl-1)
					summe = summe +SpielerEigenschaft(i)
				Next
				If summe < 2 Then 
					FreeEntity WuerfelCamera
					WuerfelCamera=0
					
					PositionEntity camera,0,5,-10
					RotateEntity camera,0,0,50
					aktplayer=4
					FlushKeys()
					FlushMouse()
					
					status = StatusMenue
				EndIf
			EndIf
	End Select 
	
	RotateEntity camera, (my-halfGraphicsHeight)/grafikdivisorHeight, -(mx-halfGraphicsWidth)/grafikdivisorWidth +PlayerPos(aktplayer,2), 0
	
	UpdateWorld()
	RenderWorld()
	
	Clear3D()
	
	WaitTimer(timer)
	Flip(0)
Until KeyHit(1)

Function NeuWuerfeln()
	If aktplayer<4 And aktplayer=>0 Then
		Local i
		WuerfelSumme = 2
		For i=0 To 1
			Local Wurf = Rand(0,5)
			WuerfelSumme = WuerfelSumme + Wurf
			RotateEntity(Msh_Wuerfel(aktplayer*2+i),WuerfelDrehung(Wurf,0)*90,Rnd(0,360),WuerfelDrehung(Wurf,1)*90)
		Next
	EndIf
End Function

Function KappeAuf()
	KappenAnimAuf=True
	If EntityY(Msh_Kappe(i))<6
		For i=0 To 3
			PositionEntity Msh_Kappe(i),EntityX(Msh_Kappe(i)),EntityY(Msh_Kappe(i))+.03,EntityZ(Msh_Kappe(i))
			TurnEntity Msh_Kappe(i),3,0,0
		Next
	Else
		KappenAnimAuf=False
		WuerfelCamera = CreateCamera()
		CameraViewport WuerfelCamera,fullGraphicWidth-200,0,200,200
		CameraZoom WuerfelCamera,2
		PositionEntity WuerfelCamera, EntityX(Msh_Kappe(aktplayer)), 6.3, EntityZ(Msh_Kappe(aktplayer))
		RotateEntity WuerfelCamera, 90,0,0
	EndIf
End Function

Function KappeZu()
	KappenAnimZu=True
	
	If WuerfelCamera<>0
		FreeEntity WuerfelCamera
		WuerfelCamera=0
	EndIf
	If KappenAnimZu
		If EntityY(Msh_Kappe(i))>4.8
			For i=0 To 3
				PositionEntity Msh_Kappe(i),EntityX(Msh_Kappe(i)),EntityY(Msh_Kappe(i))-.03,EntityZ(Msh_Kappe(i))
				TurnEntity Msh_Kappe(i),-3,0,0
			Next
		Else
			KappenAnimZu=False
		EndIf
	EndIf
End Function

Function KameraSchwenken()
	If aktplayer = KameraSchwenkZiel And aktplayer<>4
		KappenAlpha# = KappenAlpha#+.05
		EntityAlpha(Msh_Kappe(aktplayer),KappenAlpha#)
		DebugLog KappenAlpha#
		If KappenAlpha>=1 Then
			KameraSchwenk=False
			KappenAlpha=0
			ShowEntity(Msh_Wuerfel(aktplayer*2))
			ShowEntity(Msh_Wuerfel(aktplayer*2+1))
		EndIf
	Else
		KameraSchwenk=True
		Local winkel% = ATan2(PlayerPos(KameraSchwenkZiel,1)-EntityZ(camera) , PlayerPos(KameraSchwenkZiel,0)-EntityX(camera))
		PositionEntity camera, EntityX(camera)+Cos(winkel%)/2.0, 6.5, EntityZ(camera)+Sin(winkel)/2.0
		If ((PlayerPos(KameraSchwenkZiel,1)-EntityZ(camera))^2 + (PlayerPos(KameraSchwenkZiel,0)-EntityX(camera))^2)<1 Then 
			PositionEntity camera, PlayerPos(KameraSchwenkZiel,0), 6.5, PlayerPos(KameraSchwenkZiel,1)
			aktplayer = KameraSchwenkZiel
			If aktplayer = 4 Then 
				KameraSchwenk=False 
			EndIf
			Local i
			For i=0 To 3
				If aktplayer<>i
					HideEntity(Msh_Kappe(i))
					HideEntity(Msh_Wuerfel(i*2))
					HideEntity(Msh_Wuerfel(i*2+1))
				Else
					ShowEntity(Msh_Kappe(i))
					EntityAlpha(Msh_Kappe(i),0)
				EndIf
			Next
		EndIf
		If WuerfelCamera<>0 Then
			FreeEntity WuerfelCamera
			WuerfelCamera=0
		EndIf
	EndIf
End Function

Function MenueSteuerung()
	Local i
	If my <halfGraphicsHeight*1.125 Then
			;EndeButton
		If Menue_Hover_Kategorie <> 0 Then
				;switch
			EntityAlpha(msh_neu,.3)
			EntityAlpha(msh_beenden,.7)
			Menue_Hover_Kategorie = 0
			Menue_Hover_Stuhl=-1
			For i=0 To 3
				EntityColor Stuehle(i),0,0,0
			Next
		EndIf
		If mh1=True Then
			End
		EndIf
		Text3D(Font,0,-halfGraphicsHeight+20,"Spiel beenden",1)
	Else
			;Neuesspiel
		If Menue_Hover_Kategorie <> 1 Then
				;switch
			EntityAlpha(msh_neu,.7)
			EntityAlpha(msh_beenden,.3)
			Menue_Hover_Kategorie = 1
		Else
			Text3D(Font,0,-halfGraphicsHeight+20,(Menue_Hover_Stuhl+1) +" Spieler",1)
		EndIf
		If Menue_Hover_Stuhl <> mx/viertelGraphicWidth
			Menue_Hover_Stuhl = mx/viertelGraphicWidth
			For i=0 To 3
				If i=Menue_Hover_Stuhl
					SpielerAnzahl = i
					EntityColor Stuehle(i),0,0,255
				Else
					EntityColor Stuehle(i),0,0,0
				EndIf
			Next
		EndIf
		If mh1=True Then
			NewGame()
			Menue_Off()
		EndIf
	EndIf
	
	If CameraPick(camera,mx,my)=msh_beenden
		EntityAlpha(msh_beenden,.7)
		If mh1 Then End	
	Else
		EntityAlpha(msh_beenden,.3)
	EndIf
	
End Function

Function NewGame()
	Local i
	For i=0 To 3
		KartenSet$(i)="123456789"
		SpielerEigenschaft(i)=1
	Next
End Function

Function Menue_Off()
	CameraMove(0)
	HideEntity(msh_neu)
	Menue=False
End Function

Function Menue_On()
	ShowEntity(msh_neu)
	Menue=True
	CameraMove(4)
End Function

Function CameraMove(Target)
	KameraSchwenk=True
	KameraSchwenkZiel=Target
	status=StatusCameraSchwenk
End Function

Function KartenSteuerung(aktiv)
	Local karte1=-1,karte2=-1, i, ii
	Local anzahl = Len(KartenSet(aktplayer))
	Local offset = fullGraphicWidth / (anzahl+1)
	If aktiv
		For i=0 To 8
			If Instr(KartenSet(aktplayer),(i+1))
				If mx>(offset*(ii+1))-offset/2 And mx<(offset*(ii+2))-offset/2 Then
					Local hover=Mid(KartenSet(aktplayer),(ii+1),1)
					If hover = WuerfelSumme
						karte1=hover
						karte2=-1
					EndIf
					
					If Instr(KartenSet(aktplayer),WuerfelSumme-hover)  Then
						karte1=hover
						karte2=WuerfelSumme-hover
						
						If karte1=karte2 Then karte1=-1 : karte2=-1
					EndIf
				EndIf
				ii=ii+1
			EndIf
		Next
		
		Local SetOut = PeekShort(BesteSetsBank, ((StringToIntegerSet(KartenSet(aktplayer))-1)*11 + (WuerfelSumme-2))*2)
		If SetOut = 65535 Then status = StatusGameOver
		
		If mh1 And karte1>-1 Then
			KartenSet(aktplayer)=Replace(KartenSet(aktplayer),karte1,"")
			KartenSet(aktplayer)=Replace(KartenSet(aktplayer),karte2,"")
			status=StatusKappeZu
		EndIf
		
		Text3D(Font2,-halfGraphicsWidth,halfGraphicsHeight-20,"Wenn du der Bankhalter bist, drcke Enter")
		
		If KeyHit(28) Then
			SetOut = PeekShort(BesteSetsBank, ((StringToIntegerSet(KartenSet(aktplayer))-1)*11 + (WuerfelSumme-2))*2)
			KartenSet(aktplayer) = IntegerToStringSet(SetOut)
			status=StatusKappeZu
		EndIf
	EndIf
	ii=0
	For i=0 To 8
		If Instr(KartenSet(aktplayer),(i+1))
			If karte1 = Mid(KartenSet(aktplayer),ii+1,1) Or karte2 = Mid(KartenSet(aktplayer),ii+1,1)Then
				DrawImage3D(Karten(i),offset*(ii+1)-halfGraphicsWidth,-halfGraphicsHeight+50)
			Else
				DrawImage3D(Karten(i),offset*(ii+1)-halfGraphicsWidth,-halfGraphicsHeight)
			EndIf
			
			ii=ii+1
		EndIf
	Next
End Function


;~IDEal Editor Parameters:
;~F#119#1A7#1AF#1B5#1BB#1C1
;~C#Blitz3D